#!/usr/bin/python

# forrestmain.py
#
# Track your running efforts.
# Copyright (C) 2010 Bart Friederichs

import forrestgui
import pickle
import sys
import defaults
import os
from PySide import QtGui

class Settings:
	def __init__(self):
		pass
		
	def Load(self):
		print "Loading settings..."
		self.sett = defaults.settings
		
		try:
			f = open(defaults.settingsfile, 'r')
			self.sett = pickle.load(f)
			f.close()
		except IOError:
			print "Settings file not found. Using defaults."
		except EOFError:
			print "Settings file was corrupted. Using defaults."
			
		print "Settings used:"
		print self.sett
		
	def Save(self, settingstosave):
		print "Saving settings..."
		self.sett = settingstosave
		try:
			os.mkdir(defaults.workdir)
		except OSError:
			# couldn't create dir, it might already exist
			pass
		
		try:
			f = open(defaults.settingsfile, 'w')
			pickle.dump(self.sett, f)
			f.close()
			print self.sett
		except IOError:
			print "Could not write settings. Error {0}: {1} ".format(errno, strerror)
			print "Will use defaults on next startup."

	def Get(self, key, valuetype="string", default=""):
		try:
			r = self.sett[key]
		except KeyError:
			r = default
			
		if (valuetype=="int"):
			try:
				r = int(r)
			except ValueError:
				r = default
#		elif (valuetype=="string"):
#			try:
#				r = repr(r)
#			except:
#				r = default
		
		print "Selected '"+key+"', result: "+repr(r)

		return r

class ForrestMain:
	def __init__(self):
		# ForrestMain has a Settings object to hold/save/load settings
		self.settings = Settings()
		self.settings.Load()		
		
	def Run(self):
		self.app = QtGui.QApplication(sys.argv)
		
		mainwindow = forrestgui.MainWindow(self)
		mainwindow.main = self
		mainwindow.show()
		return self.app.exec_()

